#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGroupBox>
#include <QPushButton>
#include <QLabel>

#include "aboutdlg.h"

#include "images/quested1.xpm"
#include "images/gerb.xpm"
#include "images/button_ok.xpm"

/**
* 
*/
QE_AboutDlg::QE_AboutDlg(QWidget *aParent):
	QDialog(aParent)
{
	setWindowTitle(tr("About Quested"));
	QVBoxLayout *topl = new QVBoxLayout(this);
	topl->setSpacing(2);
	topl->setMargin(2);
	QHBoxLayout *hb   = new QHBoxLayout;
	hb->setSpacing(10);
    topl->addItem(hb);
	QLabel *lb = new QLabel(this);
	lb->setPixmap(QPixmap(quested1_xpm));
    hb->addWidget(lb);
	lb = new QLabel(tr("The editor for <b>What?Where?When?</b><br>"
					"version %1<br>Copyright (c) 2005 <i>Vadim Khohlov</i>").arg(QEVERSION), this);
	lb->setAlignment(Qt::AlignHCenter | Qt::AlignVCenter);
	lb->setFrameStyle(QFrame::Raised);
    hb->addWidget(lb, 1);
	lb = new QLabel(this);
	lb->setPixmap(QPixmap(gerb_xpm));
    hb->addWidget(lb);
	
	QGroupBox *gb = new QGroupBox(this);
	gb->setFlat(true);
	hb = new QHBoxLayout(gb);
	hb->setSpacing(2);
	hb->setMargin(2);
	QPushButton *pb = new QPushButton(tr("Ok"), gb);
	pb->setIcon(QIcon(button_ok));
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(accept()));
	hb->addStretch(1);
	hb->addWidget(pb);
	hb->addStretch(1);
	topl->addWidget(gb);

	setMaximumHeight(sizeHint().height());
} /* QE_AboutDlg::*aParent) */
