#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QFont>

#include "capdlg.h"

#include "images/apply.xpm"
#include "images/cancel.xpm"
#include "images/exit.xpm"

QE_CapitalDlg::QE_CapitalDlg(QE_CentralWidget *parent,
							 const QString &title,
	   						 const QStringList &aWords,
							 QTextEdit **edits,
							 int cedits,
							 const QColor &selColor,
							 int numQuests):
	QE_TransWordDlg(parent, title, edits, cedits, selColor, numQuests),
	words(aWords),
	retCode(QDialog::Rejected)
{
	QVBoxLayout *topLayout = new QVBoxLayout(this);
	QHBoxLayout *hb = new QHBoxLayout;
	hb->setSpacing(4);
	topLayout->addItem(hb);

	hb->addWidget(new QLabel(tr("Capitalize word  "), this));
	lbWord = new QLabel("ggg", this);
	lbWord->setAlignment(Qt::AlignCenter);
	QFont font(lbWord->font());
	font.setBold(true);
	lbWord->setFont(font);
	lbWord->setFrameStyle(QFrame::Raised | QFrame::Panel);
	hb->addWidget(lbWord, 1);
	hb->addWidget(new QLabel(tr(" ?"), this));

	hb = new QHBoxLayout;
	hb->setSpacing(4);
	topLayout->addItem(hb);
	QPushButton *pb = new QPushButton(QIcon(apply), tr("&Yes"), this);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotYes()));
	hb->addWidget(pb);
	pb = new QPushButton(QIcon(cancel), tr("&No"), this);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotNo()));
	hb->addWidget(pb);
	pb = new QPushButton(QIcon(exit_xpm), tr("&Close"), this);
	hb->addWidget(pb);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotClose()));
	
	setMaximumHeight(sizeHint().height());
	nextCap();
} /* QE_CapitalDlg::**edits, int cedits, const QColor &selColor, int numQuests = 0) */

/**
* \brief [    ]
*/
void
QE_CapitalDlg::nextCap()
{
	while (1)
	{
		nextWord();
		if (word.isEmpty())
		{
			slotClose();
			break;
		} /* 		if (word.isEmpty()) */

		if (words.contains(word, Qt::CaseInsensitive))
		{
			lbWord->setText(word);
			selectCurWord();
			break;
		} /* 		if (words.contains(word)) */
	} /* 	while (1) */	
} /* QE_CapitalDlg::nextCap() */

/**
* \brief   
*/
void
QE_CapitalDlg::slotNo()
{
	clearSelection();
	nextCap();
} /* QE_CapitalDlg::slotNo() */

/**
* \brief   Close
*/
void
QE_CapitalDlg::slotClose()
{
	if (! word.isEmpty())
		clearSelection();
	done(retCode);
} /* QE_CapitalDlg::slotClose() */

/**
* \brief   Yes
*/
void
QE_CapitalDlg::slotYes()
{
	retCode = QDialog::Accepted;
	clearSelection();
	replaceWord(word.toUpper());
	nextCap();
} /* QE_CapitalDlg::slotYes() */
