#include <QVBoxLayout>
#include <QGroupBox>
#include <QPushButton>
#include <QHBoxLayout>

#include "editordlg.h"
#include "qelineedit.h"
#include "tournament.h"

#include "images/button_ok.xpm"
#include "images/button_cancel.xpm"

/**
* Constructor
* \param aEditorInfo -      
*/
QE_EditorDialog::QE_EditorDialog(QE_EditorInfo *aEditorInfo, QWidget *parent):
	QDialog(parent),
	editorInfo(aEditorInfo)
{
	setWindowTitle(tr("Add the editor of tournament"));
	QVBoxLayout *topl = new QVBoxLayout(this);
	topl->setSpacing(2);
	topl->setMargin(2);
	edName = new QE_LineEdit(this, tr(" &Name:  "));
	topl->addWidget(edName);
	edEMail = new QE_LineEdit(this, tr(" E_M&ail:  "));
	topl->addWidget(edEMail);

	//buttons
	QGroupBox *gb = new QGroupBox(this);
	topl->addWidget(gb);
	gb->setFlat(true);
	QHBoxLayout *hb = new QHBoxLayout(gb);
	hb->addStretch(1);
	QPushButton *pb = new QPushButton(QIcon(button_ok), tr("Ok"), gb);
	//pb->setIcon(QIcon(button_ok));
	hb->addWidget(pb);
	pb->setDefault(true);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotOk()));
	pb = new QPushButton(QIcon(button_cancel), tr("Cancel"), gb);
	//pb->setIcon(QIcon(button_cancel));
	hb->addWidget(pb);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(reject()));

	setMaximumHeight(sizeHint().height());
} /* QE_EditorDialog::*aEditorInfo, QWidget *parent) */

/**
* Ok
*/
void
QE_EditorDialog::slotOk()
{
	editorInfo->name = edName->text();
	editorInfo->email = edEMail->text();
	accept();
} /* QE_EditorDialog::slotOk() */
