#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QListWidget>
#include <QListWidgetItem>
#include <QPushButton>
#include <QLabel>

#include "edorderwidget.h"
#include "images/upicon.xpm"
#include "images/downicon.xpm"

const char *editName[] = {
							"Question",
							"Answer",
							"Author",
							"Source",
							"Comment"
						 };

/**
* \brief 
* \params list -   
*/
QE_EdOrderWidget::QE_EdOrderWidget(const QList<int> &list, QWidget *parent):
	QWidget(parent),
	orderChanged(false)
{
	QHBoxLayout *topl = new QHBoxLayout(this);
	
	QVBoxLayout *vb = new QVBoxLayout;
	topl->addLayout(vb);
	QLabel *lb = new QLabel(tr("&Editor's order"), this);
	vb->addWidget(lb);
	liEdits = new QListWidget(this);
	vb->addWidget(liEdits);
	lb->setBuddy(liEdits);
	
	QListWidgetItem *it;
	for(int i = 0;i < list.size(); ++i)
	{
		it = new QListWidgetItem(editName[list.at(i)], liEdits);
		it->setData(1, list.at(i));
	} /* 	for(int i = 0;i < list.size(); ++i) */
	liEdits->setCurrentRow(0);

	vb = new QVBoxLayout;
	topl->addLayout(vb);
	vb->addWidget(new QLabel(tr("Select\nitems and\nmove by\nbuttons."), this));
	QPushButton *pb = new QPushButton(QIcon(upicon), tr("&Up"), this);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotUp()));
	vb->addWidget(pb);
	pb = new QPushButton(QIcon(downicon), tr("&Down"), this);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotDown()));
	vb->addWidget(pb);
} /* QE_EdOrderWidget::QStringList &list, QWidget *parent = 0) */

/**
* \brief    [
*/
void
QE_EdOrderWidget::slotUp()
{
	int prevRow, curRow = liEdits->currentRow();
	if (curRow)
	{
		prevRow = curRow - 1;
		QListWidgetItem *it = liEdits->takeItem(curRow);
		liEdits->insertItem(prevRow, it);
		liEdits->setCurrentRow(prevRow);
		orderChanged = true;
	} /* 	if (curRow) */
} /* QE_EdOrderWidget::slotUp() */

/**
* \brief    
*/
void
QE_EdOrderWidget::slotDown()
{
	int nextRow, curRow = liEdits->currentRow();
	if (liEdits->currentRow() != 4)
	{
		nextRow = curRow + 1;
		QListWidgetItem *it = liEdits->takeItem(curRow);
		liEdits->insertItem(nextRow, it);
		liEdits->setCurrentRow(nextRow);
		orderChanged = true;
	} /* 	if (liEdits->currentRow() != 4) */
} /* QE_EdOrderWidget::slotDown() */

/**
* \brief   
* \params list -   
*/
void
QE_EdOrderWidget::getList(QList<int> *list) const
{
	list->clear();
	for(int i = 0; i < liEdits->count(); ++i)
		*list << liEdits->item(i)->data(1).toInt();
} /* QE_EdOrderWidget::getList(QList<int> *list) */
