#ifndef EXPORTER_H
#define EXPORTER_H

#include <QXmlDefaultHandler>
#include <QString>

class QByteArray;
class QE_Tournament;
class QE_Quest;
/**
 * \brief   
 *    - 
 */
class QE_Exporter
{
	public:
		/**
		 * \brief 
		 * \params aFileName -    
		 */
		QE_Exporter();
		/**
		 * \brief   
		 * \params aFileName -   
		 * \returns true  [, false  
		 */
		bool load(const QString &aFileName);
		/**
		 * \brief   
		 */
		QString shortDescr() const;
		/**
		 * \brief     
		 */
		QString fileType() const;
		/**
		 * \brief     
		 */
		QString fileExt() const;
		/**
		 *     
		 *     
		 * \params body -    
		 */
		void setBody(const QString &body);
		/**
		 * \brief     
		 * \params tournament - 
		 * \params resultString -   
		 */
		void exportToString(QE_Tournament &tournament, QByteArray *resultString) const;
		/**
		 * \brief      
		 * \params tournament - 
		 * \params resultString -   
		 * \params aTurNum -   .  -1,   
		 * \params aPrintHeader - true,    
		 */
		void exportToUnicodeString(QE_Tournament &tournament, QString *resultString, 
				int aTurNum = -1, bool aPrintHeader = true) const;
	private:
		/**
		 * \brief    
		 * \params aTemplate -  
		 * \params aTourn - 
		 * \returns  
		 */
		QString exportTourn(QE_Tournament &aTourn, const QString &aTemplate) const;
		/**
		 * \brief  
		 * \params aTemplate - 
		 * \params aTourn - 
		 * \params aTurNum -  
		 * \returns  
		 */
		QString exportTur(QE_Tournament &aTourn, const QString &aTemplate, int aTurNum) const;
		/**
		 * \brief  
		 * \params aTourn - 
		 * \params qPtr -    
		 * \params aQNum -    
		 * \returns  
		 */
		QString exportQuest(QE_Tournament &aTourn, QE_Quest &qPtr, int aQNum) const;
		/**
		 * \brief   
		 * 
		 *       .      
		 *  -    
		 * \param aList -  
		 * \param isNumerate -  true,   
		 * \returns  
		 */
		QString exportList(const QStringList &aList, bool isNumerate = false) const;

		QString mShortDescr;		/*!<    ( ) */
		QString mLongDescr;			/*!<    */
		QString mFileType;			/*!<        */
		QString mFileExt;			/*!<   - */
		QString mCodePage;			/*!<    */
		QString mEol;				/*!< -[    */
		QString mList;				/*!<   */
		QString mListItem;			/*!< 1   */
		QString mItemNum;			/*!<       */
		
		QString mQuest;				/*!<   */
		QString mAnswer;			/*!<   */
		QString mScore;				/*!<   */
		QString mAuthor;			/*!<     */
		QString mComments;			/*!<   */
		QString mSource;			/*!<   */
		QString mHeader;			/*!<    */
		QString mTourHeader;		/*!<   */
		QString mQuestBody;			/*!<   */
		QString mTourFooter;		/*!<     */
		QString mFooter;			/*!<    */
		//QString mBody;				/*!<    */

		friend class QE_ExportHandler;
		/**
		 * \brief   
		 */
		class QE_ExportHandler: public QXmlDefaultHandler
		{
			public:
				/**
				 * 
				 * \params a_Exporter -   ,   
				 *  
				 */
				QE_ExportHandler(QE_Exporter *a_Exporter);
				/**
			 	 *   
			 	 */	
				bool startElement(const QString &namespaceURI, const QString &localName,
    	                  const QString &qName, const QXmlAttributes &attributes);
				/**
				 *   
				 */
		    	bool endElement(const QString &namespaceURI, const QString &localName,
        	            const QString &qName);
				/**
				 *  
				 */
	    		bool characters(const QString &str);
				/**
				 *  
				 */
    			bool fatalError(const QXmlParseException &exception);
				/**
				 *      
				 */
	    		QString errorString() const;
			private:
				QString mErrorString;		/*!<      */
				QE_Exporter *exporter;		/*!< ,     */
				QString currentText;		/*!<    */
		}; /* 		class QE_ExportHandler: public QXmlDefaultHandler */
}; /* class QE_Exporter */

inline QString QE_Exporter::shortDescr() const
{
	return mShortDescr;
} /* QE_Exporter::shortDescr() const */

inline QString QE_Exporter::fileType() const
{
	return mFileType;
} /* QE_Exporter::fileType() const */

inline QString QE_Exporter::fileExt() const
{
	return mFileExt;
} /* QE_Exporter::fileExt() const */

#endif //EXPORTER_H
