#include <QVBoxLayout>
#include <QPushButton>

#include "listedit.h"
#include "listeditdlg.h"

#include "images/edit.xpm"

/**
* \brief 
* \params aList -   
*/
QE_ListEdit::QE_ListEdit(QWidget *aParent, const QString &aLabel, 
		const QString &aButLabel):
	QE_LineEdit(aParent, aLabel)
{
	QPushButton *pb = new QPushButton(QIcon(button_edit), aButLabel, this);
	topLayout->addWidget(pb);
	topLayout->setSpacing(2);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotEdit()));
} /* QE_ListEdit::*aPrent, const QString &aLable, const QStringList &aList) */

/**
* \brief    
*      
*/
void
QE_ListEdit::setList(const QStringList &aList)
{
	mList = aList;
	if (mList.size())
		setText(mList.at(0));
	else
		edit->clear();
} /* QE_ListEdit::setList(const QStringList &aList) */

/**
* \brief   
*/
QStringList
QE_ListEdit::list()
{
	if (mList.size())
		mList[0] = text();
	else
		mList.append(text());
	return mList;
} /* QE_ListEdit::list() const */

/**
* \brief    
*/
void
QE_ListEdit::slotEdit()
{
	if (mList.size())
		mList[0] = text();
	else
		mList.append(text());

	QE_ListEditDlg dlg(this, mList);
	if (dlg.exec() == QDialog::Accepted)
	{
		mList = dlg.list();
		emit textChanged();
	} /* 	if (dlg.exec() == QDialog::Accepted) */
} /* QE_ListEdit::slotEdit() */
