#include <QVBoxLayout>
#include <QGroupBox>
#include <QPushButton>
#include <QListWidget>
#include <QInputDialog>
#include <QMessageBox>

#include "listeditdlg.h"
#include "images/button_ok.xpm"
#include "images/button_cancel.xpm"
#include "images/add.xpm"
#include "images/delete.xpm"


/**
* \brief 
* \params aList -  
*/
QE_ListEditDlg::QE_ListEditDlg(QWidget *aParent, const QStringList &aList):
	QDialog(aParent)
{
	setWindowTitle(tr("Edit list"));
	QVBoxLayout *topl = new QVBoxLayout(this);
	topl->setSpacing(2);
	topl->setMargin(2);
	lb = new QListWidget(this);
	lb->addItems(aList);
	topl->addWidget(lb);
	
	//buttons add del
	QHBoxLayout *hb = new QHBoxLayout;
	topl->addItem(hb);
	QPushButton *pb = new QPushButton(QIcon(add), tr("&Add"), this);
	hb->addWidget(pb);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotAdd()));
	pb = new QPushButton(QIcon(del), tr("&Delete"), this);
	hb->addWidget(pb);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotDel()));

	//buttons ok cancel
	QGroupBox *gb = new QGroupBox(this);
	topl->addWidget(gb);
	gb->setFlat(true);
	hb = new QHBoxLayout(gb);
	hb->addStretch(1);
	pb = new QPushButton(QIcon(button_ok), tr("Ok"), gb);
	hb->addWidget(pb);
	pb->setDefault(true);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(accept()));
	pb = new QPushButton(QIcon(button_cancel), tr("Cancel"), gb);
	hb->addWidget(pb);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(reject()));
} /* QE_ListEditDlg::*aParent, const QStringList &aList) */

/**
* \brief slot Ok
*/
void
QE_ListEditDlg::slotOk()
{
	accept();
} /* QE_ListEditDlg::slotOk() */

/**
* \brief slot add
*/
void
QE_ListEditDlg::slotAdd()
{
	QString source = QInputDialog::getText(this, tr("Add source"), tr("Enter source"));
	if (!source.isEmpty())
		lb->addItem(source);
} /* QE_ListEditDlg::slotAdd() */

/**
* \brief   
*/
QStringList
QE_ListEditDlg::list()
{
	QStringList l;
	int i, count = lb->count();
	for (i = 0; i < count; ++i)
		l.append(lb->item(i)->text());
	return l;
} /* QE_ListEditDlg::sources() */

/**
* \brief slot delete
*/
void
QE_ListEditDlg::slotDel()
{
	int row = lb->currentRow();
	if (row == -1)
		QMessageBox::warning(this, tr("Deleting"), tr("You must select deleting item"));
	else
		lb->takeItem(row);
} /* QE_ListEditDlg::slotDel() */
