#include <QSet>

#include <QComboBox>
#include <QHBoxLayout>

#include "listviewedit.h"

/**
* \brief 
* \params aLabel -  
*/
QE_ListViewEdit::QE_ListViewEdit(QWidget *aParent, const QString &aLabel, const QString &aButLabel):
	QE_ListEdit(aParent, aLabel, aButLabel)
{
	cbVariants = new QComboBox(this);
	cbVariants->setMinimumHeight(edit->height());
	topLayout->addWidget(cbVariants);
	connect(cbVariants, SIGNAL(activated(const QString&)), this, SLOT(slotVariants(const QString&)));

} /* QE_ListViewEdit::*aParent, const QString &aLabel) */

/**
* \brief   
*/
void
QE_ListViewEdit::slotVariants(const QString &aVariant)
{
	setText(aVariant);
} /* QE_ListViewEdit::slotVariants() */

/**
* \brief     
*/
void
QE_ListViewEdit::addVariants(const QSet<QString> &aStrings)
{
	foreach(QString value, aStrings)
		if(cbVariants->findText(value) == -1 && !value.isEmpty())
			cbVariants->addItem(value);
} /* QE_ListViewEdit::addVariants(const QSet<QString> &aStrings) */

/**
* \brief      .   
*   ,    [
*/
void
QE_ListViewEdit::addVariant(const QString &aString)
{
	if(cbVariants->findText(aString) == -1 && !aString.isEmpty())
		cbVariants->addItem(aString);
} /* QE_ListViewEdit::addVariant(const QString &aString) */

/**
* \brief   
*/
QSet<QString>
QE_ListViewEdit::variants()
{
	QSet<QString> authors;
	for (int i = 0; i < cbVariants->count(); ++i)
		authors.insert(cbVariants->itemText(i));
	return authors;
} /* QE_ListViewEdit::variants() */
