#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QTabWidget>
#include <QPushButton>
#include <QMessageBox>

#include "optdlg.h"
#include "optwidget.h"
#include "edorderwidget.h"

#include "images/button_ok.xpm"
#include "images/button_cancel.xpm"

/**
* \brief 
* \params aPtrOtp -      
*/
QE_OptDlg::QE_OptDlg(QWidget *parent, QE_Options *aPtrOpt, QList<int> *aEdOrder):
	QDialog(parent),
	ptrOpt(aPtrOpt),
	edOrder(aEdOrder)
{
	QVBoxLayout *topl = new QVBoxLayout(this);
	
	optWidget = new QE_OptWidget(*ptrOpt);
	QTabWidget *tabWidget = new QTabWidget;
	tabWidget->addTab(optWidget, tr("&Options"));
	orderWidget = new QE_EdOrderWidget(*edOrder);
	tabWidget->addTab(orderWidget, tr("&Editor's order"));
	topl->addWidget(tabWidget);

	QHBoxLayout *hb = new QHBoxLayout;
	topl->addLayout(hb);
	hb->addStretch(1);
	QPushButton *pb = new QPushButton(QIcon(button_ok), tr("Ok"), this);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(slotOk()));
	hb->addWidget(pb);
	pb = new QPushButton(QIcon(button_cancel), tr("Cancel"), this);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(reject()));
	hb->addWidget(pb);

	setSizeGripEnabled(true);
	setMaximumHeight(sizeHint().height());
} /* QE_OptDlg::*parent, QE_Options *aPtrOpt) */

/**
* \brief slot Ok
*   
*/
void
QE_OptDlg::slotOk()
{
	optWidget->getOptions(ptrOpt);
	orderWidget->getList(edOrder);
	if (orderWidget->isOrderChanged())
		QMessageBox::information(this, tr("Information"),
				tr("The order of editors will be changed after restarting application"),
				QMessageBox::Ok);
	accept();
} /* QE_OptDlg::slotOk() */
