#include <QApplication>
#include <QDesktopWidget>
#include <QString>
#include <QTextEdit>
#include <QVBoxLayout>
#include <QPushButton>

#include "previewdlg.h"
#include "images/button_ok.xpm"

/**
* 
* \params strHtml -    html
*/
QE_PreviewDlg::QE_PreviewDlg(const QString &strHtml, QWidget *parent):
	QDialog(parent)
{
	setWindowTitle(tr("Preview"));
	QVBoxLayout *topl = new QVBoxLayout(this);
	QTextEdit *te = new QTextEdit(this);
	topl->addWidget(te);
	te->setHtml(strHtml);
	te->setReadOnly(true);
	QPushButton *pb = new QPushButton(tr("Ok"), this);
	pb->setIcon(QIcon(button_ok));
	topl->addWidget(pb);
	connect(pb, SIGNAL(clicked(bool)), this, SLOT(accept()));

	setSizeGripEnabled(true);
	setMaximumHeight(((QApplication::desktop())->height()*9)/10);
	showMaximized();
} /* QE_PreviewDlg::QString &strHtml, QWidget *parent) */
