#ifndef QECENTRALWIDGET_H
#define QECENTRALWIDGET_H

#include <QWidget>
#include <QList>

//#ifdef Q_WS_X11
#include <aspell.h>
//#else
//#include "winclude/aspell.h"
//#endif

class QMainWindow;
class QLabel;
class QPushButton;
class QStatusBar;
class QMenu;
class QAction;
class QTextEdit;
class QCloseEvent;
class QAssistantClient;

#include "tournament.h"
#include "options.h"

class QE_Exporter;
class QE_Edit;
class QE_Edit2;
class QE_LineEdit;
class QE_LineEdit2;
class QE_ListEdit;
class QE_ListViewEdit;

const int CEDIT=5;

/**
 * \brief   
 */

class QE_CentralWidget: public QWidget
{
	Q_OBJECT
	public:
		/**
		 * \brief Constructor
		 * 
		 * \param a_parent - 
		 */
		QE_CentralWidget(QMainWindow *a_parent);
		/**
		 * \brief 
		 *
		 *   
		 */
		~QE_CentralWidget();
		/**
		 *      
		 * \param a_Menu -    
		 * \returns 0 -  
		 * 			1 -  
		 * 			2 -       html
		 */
		int loadExportInfo(QMenu *a_Menu);
		/**
		 *   
		 * \param aNumTemplate -  
		 */
		void QE_CentralWidget::exportTournament(int aNumTemplate);
		/**
		 * \brief [ 
		 */
		void saveSettings();
		/**
		 * \brief    (    ..)
		 */
		void releaseRes();
		/**
		 * \brief     
		 * \returns true -  , false - 
		 */
		bool isPackageDirty() const;
		/**
		 *      /  Edit
		 * \param aUndoAc -   action Unod
		 */
		void connectEditSignals(QAction *aUndoAc);
		/**
		 * \brief ,    
		 * \returns true - , false - 
		 */
		bool isSpellingEnable();
	signals:
		/**
		 * \brief      
		 * \param numQuest -   
		 * \param countQuests -     
		 */
		void curQuestChanged(int numQuest, int countQuests);
		/**
		 * \brief       
		 */
		void showTOD();
		/**
		 * \brief         
		 */
		void noStartupFile(const QString&);
	public slots:
		/**
		 *   
		 */
		void slotHelp();
		/**
		 *       
		 */
		void slotTournInfo();
		/**
		 *    
		 */
		void slotFileNew();
		/**
		 *     
		 */
		void slotFileSave();
		/**
		 *      
		 */
		void slotFileSaveAs();
		/**
		 *   
		 */
		void slotFileOpen();
		/**
		 *   
		 */
		void slotPreview();
		/**
		 *   "... "
		 */
		void slotWordsSkiped(QAction *ac);
		/** 
		 *       
		 */
		void slotAddQuests();
		/**
		 *   
		 */
		void slotCapital(QAction *ac);
		/**
		 *  [  . . [  
		 *   
		 */
		void slotNextQuest();
		/**
		 *  [   . [  
		 *   
		 */
		void slotFirstQuest();
		/**
		 *  [   . [  
		 *   
		 */
		void slotLastQuest();
		/**
		 *  [  . . [  
		 *   
		 */
		void slotPrevQuest();
		/**
		 *  [    . [  
		 *   
		 */
		void slotQuestN();
		/**
		 *    [ ,   ,
		 *    
		 * \param forceSave -  true,  [   
		 */
		void saveCurQuest( bool forceSave = false);
		/**
		 *     
		 */
		void slotSortQuests();
		/**
		 *    
		 */
		void slotOptions();
		/**
		 *    
		 */
		void slotSpell(QAction *ac);
		/**
		 * slot undo
		 */
		void slotUndo();
		/**
		 * slot paste
		 */
		void slotPaste();
		/**
		 * slot copy
		 */
		void slotCopy();
		/**
		 * slot Cut
		 */
		void slotCut();
		/**
		 * slot Print
		 */
		void slotPrint();
		/**
		 * \brief    " "
		 */
		void slotTOD();
		/**
		 * \brief     
		 *
		 *      [    
		 */
		void slotAddQuestsToPackage();
		/**
		 * \brief     
		 */
		void slotFindQuest();
		/**
		 * \brief     
		 */
		void slotFindPackage();
		/**
		 * \brief   
		 */
		void slotFindNext();
		/**
		 * \brief   
		 *
		 *          [ 
		 *      
		 */
		void slotNormalize();
	private slots:
		/**
		 *    
		 */
		void slotTextChanged();
		/**
		 *    
		 */
		void slotDelCurQuest();
		/**
		 * \brief        
		 */
		void slotNoStartupFile(const QString&);
	private:
		/**
		 * \brief  
		 */
		void createSpeller();
		/**
		 * \brief   
		 */
		void readSettings();
		/**
		 * \brief       
		 */
		void showCurrentQuest();
		/**
		 * \brief     
		 * \param a_fileName -   
		 * \returns  QAction    0  
		 */
		QAction* loadOneTemplate(const QString &a_fileName);
		/**
		 * \brief    (fileName)
		 */
		void openFile();
		/**
		 * \brief   [ 
		 */
		void loadCapitalWord();
		/**
		 * \brief    
		 */
		void loadAuthorsList();
		/**
		 * \brief []   
		 */
		void saveAuthorsList();
		/**
		 * \brief     
		 * \param aQuestNum -   
		 * \warning      
		 */
		void setQuest(int aQuestNum);
		/**
		 * \brief   
		 *
		 *     .   , 
		 *      .
		 * \param isStart -  true,    
		 */
		void find(bool isStart = false);
		/**
		 * \brief        
		 *
		 *  :   "-"  <<  >>, 
		 * ""  ..., " "  
		 * \param aEditor -    
		 */
		void normalizeChars(QTextEdit *aEditor);
		/**
		 * \brief   
		 *
		 *          
		 * \param aEditor - ,     
		 */
		void setPars(QTextEdit *aEditor);
		
		QLabel  *lbInfo;	/*!<   */
		QE_Edit *edQuest;	/*!<   */
		QE_Edit2 *edAComm;	/*!<     */
		QE_LineEdit2 *edAnswer;	/*!<   */
		QE_ListViewEdit *edAuthor;	/*!<   :)  */
		QE_ListEdit *edSource;	/*!<   */
		QTextEdit   *edits[CEDIT];	/*!<      */
		
		QPushButton *pbNext;	/*!<  [    */
		QPushButton *pbPrev;	/*!<  [    */
		QPushButton *pbLast;	/*!<  [    */
		QPushButton *pbFirst;	/*!<  [    */
		QPushButton *pbDelete;	/*!<    */

		QStatusBar  *stbStatusBar;	/*!<     */

		// 
		QString			fileName;		/*!<    */
		QE_Tournament 	mTournament;	/*!<    */
		int 			curNumQuest;	/*!<    */
		bool			isDirty;		/*!<        */
		bool			packageDirty;	/*!<    */
		QString			dataDir;		/*!<     (,   .) */
		QString			homeDataDir;	/*!<          */

		QString			textToFind;		/*!<     */
		enum { F_NONE, F_PACK, F_QUEST};/*!<    : ,  ,   */
		int 			findMode;		/*!<  :  ,    */
		int 			curFindQuest;	/*!<   ,     */
		bool			isCaseSensitive;/*!< true     */
		int				findPos;		/*!< ,      */
		enum { F_EQUEST, F_EANSWER, F_ESCORE, F_EAUTHOR, F_ECOMM, F_EREM, F_ESRC} 
			curFEdit;	/*  ,     */
		QString			curFText;		/*!<    */
		QTextEdit		*curFEditor;	/*!<   - */
		int 			numSrc;			/*!<  ,     */

		QVector<QE_Exporter*> exporter;		/*!<   */
		int 			htmlExporterNum;	/*!<    html ( preview) */
		QStringList		capitalWords;		/*!<  [  */
		QE_Options		options;			/*!<   */
		QList<int>		edOrder;			/*!<    */

		AspellConfig 	*aspellConfig;		/*!<   */
		AspellSpeller 	*speller;			/*!<   */

		QAssistantClient *assistant;		/*!<   */
}; /* class QE_CentralWidget: public QWidget */

inline
bool QE_CentralWidget::isPackageDirty() const
{
	return ( packageDirty || isDirty);
} /* bool isPackageDirty() const */
		
inline
bool QE_CentralWidget::isSpellingEnable()
{
	return (bool)speller;
} /* bool QE_CentralWidget::isSpellingEnable() */

#endif //QECENTRALWIDGET_H
