#include <QMessageBox>

#include "qedreader.h"
#include "tournament.h"
#include "quest.h"

/**
* 
* \param aTournament -    ,   
*  
*/
QE_QuestReader::QE_QuestReader(QE_Tournament *aTournament):
	mode(None), mTournament(aTournament), questPtr(0)
{
	
} /* QE_QuestReader::*aTournament) */

/**
*   
*/
bool QE_QuestReader::startElement(const QString & /*namespaceURI*/, 
								  const QString & /*localName*/ ,
								  const QString &qName, 
								  const QXmlAttributes &attributes)
{
	if (mode == None && qName != "tournament")
	{
        errorStr = QObject::tr("The file is not an quested file.");
        return false;
    }
	if (qName == "tournament")
		mode = Tournament;
	else if (qName == "info")
		mode = Info;
	else if (qName == "quests")
		mode = Quests;
	else if (mode == Info)
		{
			QE_TournInfoData *ti = mTournament->ptrTournInfo();
			if (qName == "metainfo" )
			{
				ti->title = attributes.value("title");
				ti->description = attributes.value("description");
				//ti->date = attributes.value("date");
				QString date(attributes.value("date"));
				ti->day   = date.section('-', 0, 0).toInt();
				ti->month = date.section('-', 1, 1).toInt();
				ti->year  = date.section('-', 2, 2).toInt();
				bool ok;
				ti->cTurQuests = attributes.value("turquests").toInt(&ok);
			} /* if (qName == "metainfo" ) */
			else if (qName == "editor" )
			{
				QE_EditorInfo ei;
				ei.name  = attributes.value("name");
				ei.email = attributes.value("email");
				ti->addEditorInfo(ei);
			} /* else if (qName == "metainfo" ) */
		} /* 	else if (mode == Info) */
	else if (mode ==Quests)
		{
			if (qName == "quest")
			{
				//  
				questPtr = new QE_Quest;
			} /* 			if (qName == "quest") */
		} /* 	else if (mode ==Quests) */	
	
	currentText.clear();
	return true;
} /* QE_QuestReader::QString &qName, const QXmlAttributes &attributes) */

/**
*   
*/
bool QE_QuestReader::endElement(const QString & /*namespaceURI*/, 
								const QString & /*localName */,
							   	const QString &qName)
{
	if (mode == Quests)
	{
		if (qName == "text")
		{
			questPtr->setText(currentText);
		} /* 		if (qName == "text") */
		else if (qName == "answer")
			questPtr->setAnswer(currentText);
		else if (qName == "score")
			questPtr->setScore(currentText);
		else if (qName == "author")
			questPtr->addAuthor(currentText);
		else if (qName == "comments")
			questPtr->setComment(currentText);
		else if (qName == "remarks")
			questPtr->setRemarks(currentText);
		else if (qName == "source")
			questPtr->addSource(currentText);
		else if (qName == "quest")
		{
			//  -   
			mTournament->addPtrQuest(questPtr);
			questPtr = 0;	//    
		} /* 		else if (qName == "quest") */
	} /* 	if(mode == Quests) */
	if (qName == "info")
		mode = Tournament;
	if (qName == "quests")
		mode = Tournament;
	return true;
} /* QE_QuestReader::QString &qName) */

/**
*  
*/
bool
QE_QuestReader::characters(const QString &str)
{
	currentText += str;
	return true;
} /* QE_QuestReader::characters(const QString &str) */

/**
*  
*/
bool
QE_QuestReader::fatalError(const QXmlParseException &exception)
{
	delete questPtr;	//    
	QMessageBox::information(0, QObject::tr("Quested"),
                             QObject::tr("Parse error at line %1, column %2:\n"
                                         "%3")
                             .arg(exception.lineNumber())
                             .arg(exception.columnNumber())
                             .arg(exception.message()));
    return false;
} /* QE_QuestReader::fatalError(const QXmlParseException &exception) */

/**
*      
*/
QString QE_QuestReader::errorString() const
{
	return errorStr;
} /* QE_QuestReader::errorString() const */
