#ifndef QEEDIT_H
#define QEEDIT_H

#include <QWidget>
#include <QTextEdit>
#include <QTextCursor>

class QHBoxLayout;

/**
 * \brief    .
 *
 *    .     
 *    .
 */
class QE_Edit: public QWidget
{
	Q_OBJECT
	public:
		/**
		 * \brief 
		 * \param a_label -  
		 * \param a_parent - widget-
		 */
		QE_Edit(QWidget *a_parent, const QString &a_label);
		/**
		 *       
		 */
		QString text();
		/**
		 *   plain   
		 */
		void setText(const QString &aText);
		/**
		 *  plain      
		 */
		void insertText(const QString &aText);
		/**
		 * \brief    
		 */
		QTextCursor cursor()
		{
			return edit->textCursor();
		} /* 		QTextCursor cursor()  */
		/**
		 * \brief    
		 */
		QTextEdit* editor()
		{
			return edit;
		} /* 		QTextEdit* editor() */
	protected:
		/**
		 *   .
		 *  [      
		 */
		void focusOutEvent(QFocusEvent *event);
		/**
		 *   .
		 *  [      
		 */
		void focusInEvent(QFocusEvent *event);
		QHBoxLayout *htopl;	/*!<  layout */
	signals:
		/**
		 *    
		 */
		void textChanged();
		/**
		 *    
		 */
		void loseFocus(QTextEdit *editor);
		/**
		 *    
		 */
		void receiveFocus(QTextEdit *editor);
	public slots:
		/**
		 *    
		 */
		void setFocus();
	protected slots:
		/**
		 *    
		 */
		void slotTextChanged();
	private:
		QTextEdit *edit;	/*!<   */
}; /* class QEEdit: public QWidget */

inline QString QE_Edit::text()
{
	return edit->toPlainText();
} /* QE_Edit::text() */

inline void QE_Edit::setText(const QString &aText)
{
	edit->setPlainText(aText);
} /* QE_Edit::setText(const QString &text) */

inline void QE_Edit::setFocus()
{
	edit->setFocus();
} /* QE_Edit::setFocus() */
		
inline void QE_Edit::insertText(const QString &aText)
{
	edit->insertPlainText(aText);
} /* inline void QE_Edit::insertText(const QString &aText) */

inline void QE_Edit::focusOutEvent(QFocusEvent *event)
{
	emit loseFocus(edit);
	QWidget::focusOutEvent(event);
} /* inline void QE_Edit::focusOutEvent(QFocusEvent *event) */

inline void QE_Edit::focusInEvent(QFocusEvent *event)
{
	emit receiveFocus(edit);
	QWidget::focusInEvent(event);
} /* inline void QE_Edit::focusOutEvent(QFocusEvent *event) */

const int countLineChars = 72;
	
#endif //QEEDIT_H
