#include <QHBoxLayout>
#include <QLabel>
#include <QTextEdit>
#include <QFontInfo>

#include "qelineedit.h"

/**
* \brief 
* \param aLabel -  
* \param aParent - widget-
*/
QE_LineEdit::QE_LineEdit(QWidget *aParent, const QString &aLabel):
	QWidget(aParent)
{
	topLayout = new QHBoxLayout(this);
	topLayout->setSpacing(0);
	topLayout->setMargin(1);
	QLabel *lb = new QLabel(aLabel, this);
	lb->setAlignment(Qt::AlignCenter);
	lb->setFrameStyle(QFrame::Box | QFrame::Sunken);
	topLayout->addWidget(lb);
	edit = new QTextEdit(this);
	edit->setTabChangesFocus(true);
	QFontInfo fontInfo(edit->font());
	edit->setMaximumHeight( lb->height() +  4);
	edit->setLineWrapMode(QTextEdit::NoWrap);
	edit->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
	
	topLayout->addWidget(edit, 1);
	lb->setBuddy(edit);

	connect(edit, SIGNAL(textChanged()), this, SLOT(slotTextChanged()));
} /* QE_LineEdit::*aParent, QString aLabel) */

/**
*    
*/
void
QE_LineEdit::slotTextChanged()
{
	emit textChanged();
} /* QE_LineEdit::slotTextChanged() */
