#include "quest.h"

QE_Quest::QE_Quest():
	mAuthors(),
	mSources()
{
	
} /* QE_Quest() */

QE_Quest::QE_Quest(const QE_Quest &aQuest):
	mText(aQuest.mText),
	mAnswer(aQuest.mAnswer),
	mScore(aQuest.mScore),
	mAuthors(aQuest.mAuthors),
	mComm(aQuest.mComm),
	mRemarks(aQuest.mRemarks),
	mSources(aQuest.mSources)
{
	
} /* QE_Quest::QE_Quest &aQuest) */

/**
*    
* \param aText -  
* \param aAnswer - 
* \param aAuthors -  
* \param aComm   - 
* \param aSource -  
* \param aScore  -  
* \param aRemarks  -   
*/
void QE_Quest::setQuestInfo(const QString &aText, const QString &aAnswer,
const QStringList &aAuthors, const QString &aComm, const QString &aScore,
const QString &aRemarks, const QString &aSource)
{
	mText   = aText;
	mAnswer = aAnswer;
	mScore  = aScore;
	mAuthors = aAuthors;
	mComm   = aComm;
	mRemarks= aRemarks;
	mSources.clear();
	if(!aSource.isEmpty())
		mSources.append(aSource);
} /* QE_Quest::QString &aComm = Qstring(), const QString &aSource = QString()) */

/**
*    XML-   
* \param writer -     
*/ 
void
QE_Quest::save(XMLWriter &writer) const
{
	writer.writeOpenTag("quest");
	
	writer.writeTaggedString("text", mText);
	writer.writeTaggedString("answer", mAnswer);
	if (!mScore.isEmpty())
		writer.writeTaggedString("score", mScore);
	
	foreach(QString author, mAuthors)
		writer.writeTaggedString("author", author);
	
	if (!mComm.isEmpty())
		writer.writeTaggedString("comments", mComm);
	
	if (!mRemarks.isEmpty())
		writer.writeTaggedString("remarks", mRemarks);

	for(QStringList::const_iterator it = mSources.constBegin();
			it != mSources.constEnd(); ++it)
		writer.writeTaggedString("source", *it);
	
	writer.writeCloseTag("quest");
} /* QE_Quest::save(const XMLWriter &writer) const */

/**
*    
* \param aText -  
* \param aAnswer - 
* \param aAuthor - 
* \param aComm   - 
* \param aSources -  
* \param aScore  -  
* \param aRemarks  -   
*/
void QE_Quest::setQuestInfo(const QString &aText, const QString &aAnswer,
				const QStringList &aAuthors,	const QString &aComm,
			   	const QString &aScore, const QStringList &aSources,
				const QString &aRemarks)
{
	setQuestInfo(aText, aAnswer, aAuthors, aComm, aScore, aRemarks);
	mSources = aSources;
} /* QE_Quest::setQuestInfo(const QString &aText, const QString &aAnswer */

