#ifndef QUEST_H
#define QUEST_H

#include <QString>
#include <QStringList>

#include "XMLWriter.h"
#include "quest.h"

/**
 * ,   
 */
class QE_Quest
{
	public:
		/**
		 * \brief 
		 *
		 *    
		 */
		QE_Quest();
		/**
		 * \brief  
		 *
		 *   
		 */
		QE_Quest(const QE_Quest &aQuest);
		/**
		 * \brief    
		 *
		 *       
		 * \param aText -  
		 * \param aAnswer - 
		 * \param aAuthors -  
		 * \param aComm   - 
		 * \param aSource -  
		 * \param aScore  -  
		 * \param aRemarks  -   
		 */
		void setQuestInfo(const QString &aText, const QString &aAnswer,
				const QStringList &aAuthors, const QString &aComm, 
				const QString &aScore = QString(), 
				const QString &aRemarks = QString(),
				const QString &aSource = QString());
		/**
		 * \brief    
		 * 
		 *       
		 * \param aText -  
		 * \param aAnswer - 
		 * \param aAuthors -  
		 * \param aComm   - 
		 * \param aSources -  
		 * \param aScore  -  
		 * \param aRemarks  -   
		 */
		void setQuestInfo(const QString &aText, const QString &aAnswer,
				const QStringList &aAuthors,	const QString &aComm,
				const QString &aScore, 	const QStringList &aSources,
				const QString &aRemarks = QString());
		/**
		 *    XML-   
		 * \param writer -     
		 */ 
		void save(XMLWriter &writer) const;
		/**
		 *   
		 */
		QString text() const;
		/**
		 *   
		 * \param aText - 
		 */
		void setText(const QString &aText);
		/**
		 *   
		 */
		QString answer() const;
		/**
		 *   
		 * \param aText - 
		 */
		void setAnswer(const QString &aText);
		/**
		 *   
		 */
		QString score() const;
		/**
		 *   
		 * \param aText - 
		 */
		void setScore(const QString &aText);
		/**
		 *    
		 */
		QStringList authors() const ;
		/**
		 *    
		 * \param aText - 
		 */
		void addAuthor(const QString &aText);
		/**
		 *         
		 * \param aNum -  
		 */
		QString author(int aNum = 0) const;
		/**
		 *    
		 */
		int countAuthors() const; 
		/**
		 *   
		 */
		QString comment() const ;
		/**
		 *    
		 * \param aText - 
		 */
		void setComment(const QString &aText);
		/**
		 * \brief    
		 */
		QString remarks() const ;
		/**
		 * \brief    
		 * \param aText -  
		 */
		void setRemarks(const QString &aText);
		/**
		 *   
		 * \param aText - 
		 */
		void addSource(const QString &aText);
		/**
		 *        
		 * \param aNum -  
		 */
		QString source(int aNum = 0) const;
		/**
		 *    
		 */
		int countSources() const; 
		/**
		 * \brief   
		 */
		QStringList sources() const;
		/**
		 *    
		 */
		void setSources(const QStringList &aSources);

	private:
		QString mText;				/*!<   */
		QString mAnswer;			/*!<  */
		QString mScore;				/*!< :   */
		QStringList mAuthors;		/*!<  */
		QString mComm;				/*!<   */
		QString mRemarks;			/*!<    */
		QStringList mSources;		/*!<  */
}; /* class QE_Quest */

inline void QE_Quest::setText(const QString &aText)
{
	mText = aText;
} /* QE_Quest::setText(const QString &aText) */

inline QString QE_Quest::text() const
{
	return mText;
} /* QE_Quest::text() const */

inline void QE_Quest::setAnswer(const QString &aText)
{
	mAnswer = aText;
} /* QE_Quest::setText(const QString &aText) */

inline QString QE_Quest::answer() const
{
	return mAnswer;
} /* QE_Quest::text() const */

inline void QE_Quest::setScore(const QString &aText)
{
	mScore = aText;
} /* QE_Quest::setScore(const QString &aText) */

inline QString QE_Quest::score() const
{
	return mScore;
} /* QE_Quest::score() const */

inline void QE_Quest::addAuthor(const QString &aText)
{
	mAuthors.append(aText);
} /* QE_Quest::setText(const QString &aText) */

inline QStringList QE_Quest::authors() const
{
	return mAuthors;
} /* QE_Quest::text() const */

inline QString QE_Quest::author(int aNum) const
{
	return (aNum < mAuthors.size() ? mAuthors[aNum] : QString());
} /* inline QString souce(int aNum) const */

inline int QE_Quest::countAuthors() const
{
	return mAuthors.size();
} /* inline QE_Quest::int countSources() const */

inline void QE_Quest::setComment(const QString &aText)
{
	mComm = aText;
} /* QE_Quest::setText(const QString &aText) */

inline void QE_Quest::setRemarks(const QString &aText)
{
	mRemarks = aText;
} /* QE_Quest::setText(const QString &aText) */

inline QString QE_Quest::remarks() const
{
	return mRemarks;
} /* QE_Quest::text() const */

inline QString QE_Quest::comment() const
{
	return mComm;
} /* QE_Quest::text() const */

inline void QE_Quest::addSource(const QString &aText)
{
	if (!aText.isEmpty())
		mSources.append(aText);
} /* inline void addSource(const QString &aText) */

inline QString QE_Quest::source(int aNum) const
{
	return (aNum < mSources.size() ? mSources[aNum] : QString());
} /* inline QString souce(int aNum) const */

inline int QE_Quest::countSources() const
{
	return mSources.size();
} /* inline QE_Quest::int countSources() const */

inline QStringList QE_Quest::sources() const
{
	return mSources;
} /* inline QStringList sources() const */
		
inline void QE_Quest::setSources(const QStringList &aSources)
{
	mSources = aSources;
} /* inline void setSources(const QStringList &aSources) */
#endif //QUEST_H
