#ifndef TOURNAMENT_H
#define TOURNAMENT_H

#include <QString>
#include <QSet>
#include <QVector>

class QE_Quest;

/**
 *       
 */
struct QE_EditorInfo
{
	QString name,
			email;
}; /* struct QE_EditorInfo */

/**
 * ,    
 */
struct QE_TournInfoData
{
	QString title,
			description;
	int		day, month, year;
	QVector<QE_EditorInfo> editors;
	int		cTurQuests;	/*!<     */
	/**
	 *     
	 * \param aEditorInfo - 
	 */
	void addEditorInfo(const QE_EditorInfo &aEditorInfo);
	/**
	 *   
	 */
	void clearEditors();
}; /* struct QEToutnInfoData */

/**
 * \brief ,    .
 */
class QE_Tournament
{
	public:
		/**
		 * Constructor
		 */
		QE_Tournament();
		/**
		 * \brief 
		 *
		 *   
		 */
		~QE_Tournament() { clear(); }
		/**
		 * \brief    :
		 * - 
		 * - 
		 * -  
		 * -  
		 * \param tourInfo -   \ref XTourInfoData,
		 *    .
		 */
		void setTournamentInfo(const QE_TournInfoData &aTourInfo);
		/**
		 * \brief    
		 */
		void getTournamentInfo(QE_TournInfoData *aTourInfo) const;

		/**
		 * \brief    
		 * \param aFileName -  
		 * \returns true  [, false -  
		 */
		bool save(const QString &aFileName) const;
		/**
		 * \brief    
		 * \param aFileName -  
		 * \returns true  [, false -  
		 */
		bool load(const QString &aFileName);
		/**
		 *       QE_TournInfoData
		 */
		QE_TournInfoData* ptrTournInfo();
		/**
		 *    .     
		 * \param aPtrQuest -   
		 */
		void addPtrQuest(QE_Quest *aPtrQuest);
		/**
		 * \brief    
		 *
		 *     
		 * \param aQuestNum -   
		 * \warning    
		 */
		void removeQuest(int aQuestNum);
		/**
		 *        
		 * \param aNum -  
		 * \warning    
		 */
		QE_Quest* ptrQuest(int aNum);
		/**
		 *      
		 */
		int countQuests() const;
		/**
		 *    :     
		 */
		void clear();
		/**
		 * \brief    
		 * \param newOrder -      
		 */
		void reorder(int *newOrder);
		/**
		 * \brief     
		 */
		QSet<QString> authors() const;
	private:
		QE_TournInfoData mTournInfoData;	/*!<    */
		QVector<QE_Quest*>	mQuests;		/*!<   */
}; /* class QE_Tournament */

inline QE_TournInfoData* QE_Tournament::ptrTournInfo()
{
	return &mTournInfoData;
} /* QE_TournInfoData* prtTournInfo() */

inline void QE_TournInfoData::addEditorInfo(const QE_EditorInfo &aEditorInfo)
{
	editors.append(aEditorInfo);
} /* QE_Tournament::addEditorInfo(const QE_EditorInfo &aEditorInfo) */

inline void QE_TournInfoData::clearEditors()
{
	editors.clear();
} 

inline void QE_Tournament::addPtrQuest(QE_Quest *aPtrQuest)
{
	mQuests.append(aPtrQuest);
} /* QE_Tournament::addPtrQuest(QE_Quest *aPtrQuest) */

inline QE_Quest* QE_Tournament::ptrQuest(int aNum)
{
	return mQuests[aNum];
} /* inline QE_Quest* ptrQuest(int aNum) */
		
inline int QE_Tournament::countQuests() const
{
	return mQuests.size();
} /* inline int countQuests() const */
#endif //TOURNAMENT_H
