#include <QString>
#include <QTextEdit>

#include "transworddlg.h"
#include "qecentralwidget.h"

QE_TransWordDlg::QE_TransWordDlg(QE_CentralWidget *aParent, const QString &title,
	QTextEdit **aEdits, int aCedits, const QColor &selColor, int aNumQuests):
	QDialog((QWidget*)aParent),
	parent(aParent),
	edits(aEdits),
	cedits(aCedits),
	numQuests(aNumQuests),
	curEdit(-1)
{
	selFormat.setForeground(QBrush(selColor));
	setWindowTitle(title);
	if (numQuests)
	{
		parent->slotFirstQuest();
		--numQuests; //     
	} /* 	if (numQuests) */
} /* QE_TransWordDlg::**edits, int cedits, const QColor &selColor, int numQuests = 0) */

/**
* \brief      
*/
void
QE_TransWordDlg::selectCurWord()
{
	cursor.setCharFormat(selFormat);
} /* QE_TransWordDlg::selectCurWord() */

/**
* \brief    
*/
void
QE_TransWordDlg::nextWord()
{
	if (curEdit >= cedits)
		return;
	do
	{
		if (curEdit != - 1)
			cursor.movePosition(QTextCursor::NextWord);
		while (curEdit == -1 || cursor.atEnd())
		{	//[   
			if (++curEdit >= cedits)
			{
				if (numQuests)
				{
					--numQuests;
					curEdit = 0;
					parent->saveCurQuest(true);
					parent->slotNextQuest();
				} /* if (numQuests) */
				else
				{
					word = "";
					return;
				} /* 	else */
			} /* 			if (++curEdit >= cedits) */
			cursor = edits[curEdit]->textCursor();
			defFormat = cursor.charFormat();
			cursor.movePosition(QTextCursor::Start);
		} /* 		if (curEdit == -1 || cursor.atEnd()) */
		//cursor.movePosition(QTextCursor::StartOfWord);
		cursor.movePosition(QTextCursor::EndOfWord, QTextCursor::KeepAnchor);
		word = cursor.selectedText().trimmed();
	} while (word.isEmpty());
} /* QE_TransWordDlg::nextWord() */

