#ifndef TRANSWORDDLG_H
#define TRANSWORDDLG_H

#include <QDialog>
#include <QTextCursor>
#include <QTextCharFormat>

class QE_CentralWidget;
class QString;
class QTextEdit;

/**
 * \brief    .
 * 
 *     , [ 
 *  .          
 * .
 */

class QE_TransWordDlg: public QDialog
{
	Q_OBJECT
	public:
		/**
		 * \brief 
	 	 *  
	 	 * \params parent - -
	 	 * \params title -  
	 	 * \params edits - 
	 	 * \params cedits -  
	 	 * \params selColor -    
	 	 * \params numQuests -   ( 0 -     )
	 	 */
		QE_TransWordDlg(QE_CentralWidget *aParent, const QString &title,
				QTextEdit **aEits, int aCedits, const QColor &selColor, int aNumQuests = 0);
		/**
		 * \brief  true   [
		 */
		bool isTransformNeeded();
	protected:
		/**
		 * \brief      
		 */
		void selectCurWord();
		/**
		 * \brief   
		 */
		void clearSelection();
		/**
		 * \brief    
		 */
		void nextWord();
		/**
		 * \brief    
		 * \param aNewWord - -
		 */
		void replaceWord(const QString &aNewWord);
		
		QString				word;		/*!<    */
	private:
		QE_CentralWidget    *parent;	/*!<  -    */
		QTextCursor	cursor;				/*!<     */
		QTextCharFormat		selFormat;	/*!<     */
		QTextCharFormat		defFormat;	/*!<    */
		QTextEdit			**edits;	/*!<  */
		int					cedits;		/*!<  [  */
		int					numQuests;	/*!<  [  */
		int 				curEdit;	/*!<     */
}; /* class QE_TransWordDlg: public QDialog */

inline
void QE_TransWordDlg::replaceWord(const QString &aNewWord)
{
			cursor.insertText(aNewWord);
} /* 		void replaceWord(const QString &aNewWord) */

inline
void QE_TransWordDlg::clearSelection()
{
	cursor.setCharFormat(defFormat);
} /* QE_TransWordDlg::clearSelection() */

inline
bool QE_TransWordDlg::isTransformNeeded()
{
	return !word.isEmpty();
} /* bool QE_TransWordDlg::isTransformNeeded() */

#endif //TRANSWORDDLG_H
